#include <vector>
#include <algorithm>
#include <memory>
#include <SDL.h>
#include <SDL_image.h>
#include <SDL_ttf.h>
#include <random>

Sint64 size(SDL_RWops* instance)
{
	SDL_Log("Size");
	return -1;
};

Sint64 seek(SDL_RWops* instance, Sint64 NewPosition, int whence)
{
	SDL_Log("Seek");
	return -1;
};

size_t read(SDL_RWops* instance, void* ReadTo, size_t OneObjectSize, size_t ObjectsToRead)
{
	SDL_Log("Read");
	Uint64 BytesToRead = OneObjectSize * ObjectsToRead; //kolik byt pest
	Uint8* Begin = (Uint8*)ReadTo;	//odkud zat st
	Uint8* End = Begin + BytesToRead; //kde ukonit ten
	while (Begin != End)
	{
		*Begin = rand(); //vloen nhodn hodnoty
		Begin += sizeof(Uint8);
	}
	return ObjectsToRead;
};

size_t write(SDL_RWops* instance, const void* Data, size_t OneObjectSize, size_t CountOfObjects)
{
	SDL_Log("Write");
	return 0;
};

int close(SDL_RWops* instance)
{
	SDL_Log("Close");
	SDL_FreeRW(instance);
	return 0;
};

#define CountOfValues 255

int SDL_main(int, char**)
{
	//inicializace SDL - pouze video
	SDL_Init(SDL_INIT_VIDEO);

	//vytvoen okna
	SDL_Window* MainWindow = SDL_CreateWindow("Fronta udalosti", //jmno okna
		SDL_WINDOWPOS_CENTERED, //okno bude vytvoeno ve stedu obrazovky
		SDL_WINDOWPOS_CENTERED,
		800, 600, NULL); //ka, vka a flagy okna (ty nepotebujeme)


	//vytvoen rendereru
	SDL_Renderer* renderer = SDL_CreateRenderer(MainWindow, -1, SDL_RENDERER_ACCELERATED);
	SDL_Event *events = new SDL_Event;

	SDL_RWops* MyInstance = SDL_AllocRW();
	MyInstance->size = size;
	MyInstance->seek = seek;
	MyInstance->read = read;
	MyInstance->write = write;
	MyInstance->close = close;
	MyInstance->type = SDL_RWOPS_UNKNOWN;

	int MyArray[CountOfValues];
	memset(MyArray, 0, CountOfValues);
	SDL_RWread(MyInstance, MyArray, sizeof(int), CountOfValues);

	while (!SDL_QuitRequested())						//zatek hlavn smyky
	{

		while (SDL_PollEvent(events))
		{
			if (events->type == SDL_KEYDOWN && events->key.keysym.scancode == SDL_SCANCODE_R)
				for (int a = 0;a < CountOfValues;a++)
					SDL_Log("%u", *(MyArray + a));
		}




		SDL_SetRenderDrawColor(renderer, 0, 0, 255, 255);		//nastaven barvy, kterou se bude vykreslovat pozad
		SDL_RenderClear(renderer);								//vykreslen pozad

		SDL_RenderPresent(renderer);							//aktualizace okna
	}

	//nen poteba mazat jednotliv objekty, po ukonen programu voln msto automaticky promae OS

	SDL_Quit();								//Ukonen SDL
	return 0;
}